#!/usr/bin/env python
# -*- coding: utf-8 -*-
# -*- Python -*-

"""
 @file RTC_RPY_Viewer.py
 @brief Roll.Pitch,Yawの表示
 @date $Date$

 @author @author 株式会社アイザック
 研究開発部
 河野　智也
 kohno@aizuk.jp

 MIT

"""
import sys
import time
sys.path.append(".")

# Import RTM module
import RTC
import OpenRTM_aist
import rpy_viewer
import math

pose_ =[]
pose_ = 10 * [0]
Orientation_ =[]
Orientation_ = 5 * [0]
# Import Service implementation class
# <rtc-template block="service_impl">

# </rtc-template>

# Import Service stub modules
# <rtc-template block="consumer_import">
# </rtc-template>


# This module's spesification
# <rtc-template block="module_spec">
rtc_rpy_viewer_spec = ["implementation_id", "RTC_RPY_Viewer", 
		 "type_name",         "RTC_RPY_Viewer", 
		 "description",       "Roll.Pitch,Yawの表示", 
		 "version",           "1.0.0", 
		 "vendor",            "AIZUK", 
		 "category",          "View", 
		 "activity_type",     "STATIC", 
		 "max_instance",      "1", 
		 "language",          "Python", 
		 "lang_type",         "SCRIPT",
		 "conf.default.Read_Port", "TimedPose3D",
		 "conf.__widget__.Read_Port", "radio",
		 "conf.__constraints__.Read_Port", "(TimedPose3D,TimedOrientation3D)",
		 ""]
# </rtc-template>

##
# @class RTC_RPY_Viewer
# @brief Roll.Pitch,Yawの表示
# 
# RTC_RPY_Viewer
#	Roll.Pitch,Yawのグラフィカルな表示
# 
# 入力：
#	TimedPose3D,TimedOrientation3D,Pose3D,Orientation3D
#	どれかをコンフィギュレーションで1つ選択
# 
# Kivy:https://kivy.org/#home
# 
# 
class RTC_RPY_Viewer(OpenRTM_aist.DataFlowComponentBase):
	
	##
	# @brief constructor
	# @param manager Maneger Object
	# 
	def __init__(self, manager):
		OpenRTM_aist.DataFlowComponentBase.__init__(self, manager)

		self._d_TimedPose3D = RTC.TimedPose3D(RTC.Time(0,0), RTC.Pose3D(RTC.Point3D(0.0,0.0,0.0), RTC.Orientation3D(0.0,0.0,0.0)))
		"""
		"""
		self._TimedPose3DIn = OpenRTM_aist.InPort("TimedPose3D", self._d_TimedPose3D)
		self._d_TimedOrientation3D = RTC.TimedOrientation3D(RTC.Time(0,0), RTC.Orientation3D(0.0,0.0,0.0))
		"""
		"""
		self._TimedOrientation3DIn = OpenRTM_aist.InPort("TimedOrientation3D", self._d_TimedOrientation3D)

		


		# initialize of configuration-data.
		# <rtc-template block="init_conf_param">
		"""
		
		 - Name:  Read_Port
		 - DefaultValue: TimedPose3D
		"""
		self._Read_Port = ['TimedPose3D']
		
		# </rtc-template>


		 
	##
	#
	# The initialize action (on CREATED->ALIVE transition)
	# formaer rtc_init_entry() 
	# 
	# @return RTC::ReturnCode_t
	# 
	#
	def onInitialize(self):
		# Bind variables and configuration variable
		self.bindParameter("Read_Port", self._Read_Port, "TimedPose3D")
		
		# Set InPort buffers
		self.addInPort("TimedPose3D",self._TimedPose3DIn)
		self.addInPort("TimedOrientation3D",self._TimedOrientation3DIn)
		
		# Set OutPort buffers
		
		# Set service provider to Ports
		
		# Set service consumers to Ports
		
		# Set CORBA Service Ports
		
		return RTC.RTC_OK
	
		##
		# 
		# The finalize action (on ALIVE->END transition)
		# formaer rtc_exiting_entry()
		# 
		# @return RTC::ReturnCode_t
	
		# 
	def onFinalize(self):
	
		return RTC.RTC_OK
	
		##
		#
		# The startup action when ExecutionContext startup
		# former rtc_starting_entry()
		# 
		# @param ec_id target ExecutionContext Id
		#
		# @return RTC::ReturnCode_t
		#
		#
	def onStartup(self, ec_id):
	
		return RTC.RTC_OK
	
		##
		#
		# The shutdown action when ExecutionContext stop
		# former rtc_stopping_entry()
		#
		# @param ec_id target ExecutionContext Id
		#
		# @return RTC::ReturnCode_t
		#
		#
	def onShutdown(self, ec_id):
	
		return RTC.RTC_OK
	
		##
		#
		# The activated action (Active state entry action)
		# former rtc_active_entry()
		#
		# @param ec_id target ExecutionContext Id
		# 
		# @return RTC::ReturnCode_t
		#
		#
	def onActivated(self, ec_id):
	
		return RTC.RTC_OK
	
		##
		#
		# The deactivated action (Active state exit action)
		# former rtc_active_exit()
		#
		# @param ec_id target ExecutionContext Id
		#
		# @return RTC::ReturnCode_t
		#
		#
	def onDeactivated(self, ec_id):
	
		return RTC.RTC_OK
	
		##
		#
		# The execution action that is invoked periodically
		# former rtc_active_do()
		#
		# @param ec_id target ExecutionContext Id
		#
		# @return RTC::ReturnCode_t
		#
		#
	def onExecute(self, ec_id):
#		self._Read_Port = ['TimedPose3D']
                Port_Select = 0
                #Pose
	        if self._Read_Port==['TimedPose3D']:
	        	Port_Select=0
#	        	print self._Read_Port

		#Orientation
	        elif self._Read_Port==['TimedOrientation3D']:
	        	Port_Select=1
#	        	print self._Read_Port
	        #Pose	
		if(self._TimedPose3DIn.isNew()) and Port_Select==0:
			
	                POSE = self._TimedPose3DIn.read()
	                pose_[0] = POSE.data.position.x
	                pose_[1] = POSE.data.position.y
	                pose_[2] = POSE.data.position.z
	                
	                pose_[3] = ( POSE.data.orientation.r ) 
	                pose_[4] = ( POSE.data.orientation.p )
	                pose_[5] = ( POSE.data.orientation.y )
	                S=rpy_viewer.Send()
	                S.send_Pose(pose_)
	        	
		#Orientation
		if(self._TimedOrientation3DIn.isNew()) and Port_Select==1:
			
	                POSE = self._TimedOrientation3DIn.read()
	                pose_[0] = 0
	                pose_[1] = 0
	                pose_[2] = 0
	                
	                pose_[3] = ( POSE.data.r ) 
	                pose_[4] = ( POSE.data.p )
	                pose_[5] = ( POSE.data.y )
	                S=rpy_viewer.Send()
	                S.send_Pose(pose_)
		return RTC.RTC_OK
	
		##
		#
		# The aborting action when main logic error occurred.
		# former rtc_aborting_entry()
		#
		# @param ec_id target ExecutionContext Id
		#
		# @return RTC::ReturnCode_t
		#
		#
	def onAborting(self, ec_id):
	
		return RTC.RTC_OK
	
		##
		#
		# The error action in ERROR state
		# former rtc_error_do()
		#
		# @param ec_id target ExecutionContext Id
		#
		# @return RTC::ReturnCode_t
		#
		#
	def onError(self, ec_id):
	
		return RTC.RTC_OK
	
		##
		#
		# The reset action that is invoked resetting
		# This is same but different the former rtc_init_entry()
		#
		# @param ec_id target ExecutionContext Id
		#
		# @return RTC::ReturnCode_t
		#
		#
	def onReset(self, ec_id):
	
		return RTC.RTC_OK
	
		##
		#
		# The state update action that is invoked after onExecute() action
		# no corresponding operation exists in OpenRTm-aist-0.2.0
		#
		# @param ec_id target ExecutionContext Id
		#
		# @return RTC::ReturnCode_t
		#

		#
	def onStateUpdate(self, ec_id):
	
		return RTC.RTC_OK
	
		##
		#
		# The action that is invoked when execution context's rate is changed
		# no corresponding operation exists in OpenRTm-aist-0.2.0
		#
		# @param ec_id target ExecutionContext Id
		#
		# @return RTC::ReturnCode_t
		#
		#
	def onRateChanged(self, ec_id):
	
		return RTC.RTC_OK
	



def RTC_RPY_ViewerInit(manager):
    profile = OpenRTM_aist.Properties(defaults_str=rtc_rpy_viewer_spec)
    manager.registerFactory(profile,
                            RTC_RPY_Viewer,
                            OpenRTM_aist.Delete)

def MyModuleInit(manager):
    RTC_RPY_ViewerInit(manager)

    # Create a component
    comp = manager.createComponent("RTC_RPY_Viewer")

def main():
	#global GUI
	#GUI=rpy_viewer.RootWidget()
	mgr = OpenRTM_aist.Manager.init(sys.argv)
	#mgr.setModuleInitProc(MyModuleInit)
  	mgr.activateManager()
	RTC_RPY_ViewerInit(mgr)
	mgr.runManager(True)
        comp = mgr.createComponent("RTC_RPY_Viewer")
        GUI_kivy = rpy_viewer.rpy_viewerApp().run()

if __name__ == "__main__":
	main()

